@echo off
rem --------------------------------------------------------------------------
rem Licensed Materials - Property of IBM
rem  
rem 5724-A78
rem
rem (C) Copyright IBM Corp. 2001 All Rights Reserved.
rem
rem US Government Users Restricted Rights - Use, duplication or
rem disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem
rem @(#) src/batch/config/PAM.bat, BPIP.IC.Win32, M210 1.13 01/05/11 21:22:12
rem --------------------------------------------------------------------------


call :print +++ Entering PAM.bat

rem ******************************************************************************
rem *
rem * Parameters used
rem *
rem ******************************************************************************

call :print **** Getting the DB2 Server directory
call BizTmapiGet SoftwareProduct %BIZ_TAMHOST% _r_tam _p_db2
call errors %BIZ_LOG% %TMAPI.ERROR% pam.bat
if not defined TMAPI.PRODUCT.INSTALLDIR (
call BizTmapiGet SoftwareProduct %BIZ_TAMHOST% _r_tamplus _p_db2)
call errors %BIZ_LOG% %TMAPI.ERROR% pam.bat

IF NOT "%TMAPI.ERROR%"=="0" goto nodbdir

set DB_SERVER_DIR=%TMAPI.PRODUCT.INSTALLDIR%

:dbdir

set DB_INSTANCE=DB2
set DB_USERNAME=db2admin

appender p "Input DB2 Password for username DB2ADMIN" %temp%\~tmp.bat
call %temp%\~tmp.bat
set DB_PASSWORD=%BIZ_PW%
del %temp%\~tmp.bat

rem *******************************
rem *
rem * Moving of the four .jar files
rem *

call :print **** Copying mail.jar, activation.jar and pop3.jar into %BIZ_WSJAVADIR%\jre\lib\ext
mkdir %BIZ_WSJAVADIR%\jre\lib\ext
copy mail.jar %BIZ_WSJAVADIR%\jre\lib\ext
copy activation.jar %BIZ_WSJAVADIR%\jre\lib\ext
copy pop3.jar %BIZ_WSJAVADIR%\jre\lib\ext
copy %BIZ_JMSDIR%\lib\ldap.jar %BIZ_WSJAVADIR%\jre\lib\ext

call :print **** Copying mail.jar, activation.jar and pop3.jar into %BIZ_JAVADIR%\lib\ext
mkdir %BIZ_JAVADIR%\lib\ext
copy mail.jar %BIZ_JAVADIR%\lib\ext
copy activation.jar %BIZ_JAVADIR%\lib\ext
copy pop3.jar %BIZ_JAVADIR%\lib\ext
copy %BIZ_JMSDIR%\lib\ldap.jar %BIZ_JAVADIR%\lib\ext

rem *******************************
rem *
rem * Creation of database
rem *

call :print **** Connecting to DB2 Database

call :print **** Checking whether DB2 Server is installed

appender r "software\ibm\websphere business integrator\products\DB2\components" "server" %TEMP%\~tmp.bat
call %TEMP%\~tmp.bat
del %TEMP%\~tmp.bat
if defined BPIPCONFIG goto setdbname

set DB_INSTANCE=WSBIPAM

echo catalog tcpip node %DB_INSTANCE% remote %BIZ_TAMHOST% server 50000 remote_instance db2;  > %TEMP%\~tmp.txt
echo.  >> %TEMP%\~tmp.txt
echo ATTACH TO %DB_INSTANCE% USER %DB_USERNAME% using %DB_PASSWORD% >> %TEMP%\~tmp.txt
echo terminate;  >> %TEMP%\~tmp.txt

db2cmd /c /w db2 -o -v -t -s -f %TEMP%\~tmp.txt -z %TEMP%\%DB_INSTANCE%.log
del %TEMP%\~tmp.txt
if NOT %ERRORLEVEL% == 0 goto remoteproblem

:setdbname
SET DB_NAME=WSBIPAM

:checkname
if exist %temp%\~tmp.log del %temp%\~tmp.log
call :print **** Checking to see whether database "%DB_NAME%" already exists
if "%DB_NAME%" == "" goto noname 
echo ATTACH TO %DB_INSTANCE% USER %DB_USERNAME% USING %DB_PASSWORD%; > %TEMP%\~tmp.sql
echo CONNECT TO %DB_NAME% USER %DB_USERNAME% USING %DB_PASSWORD%; >> %TEMP%\~tmp.sql
db2cmd -c -w -i db2  -vf %temp%\~tmp.sql -t -z %TEMP%\~tmp.log
del %temp%\~tmp.sql
find /i "SQLSTATE=42705" "%TEMP%\~tmp.log" >nul
if %ERRORLEVEL% == 0 goto callnewdb
if NOT %ERRORLEVEL% == 0 goto questiondrop

:questiondrop
if exist %temp%\~tmp.txt del %TEMP%\~tmp.txt
call :print **** Database "%DB_NAME%" already exists. Prompting user to decide whether or not to recreate the database.
echo "The database %DB_NAME% already exists. Do you want to recreate this database?" > %TEMP%\~tmp.txt
echo "NOTE: All existing data will be lost. Select "No" to create the database with a new name." >> %TEMP%\~tmp.txt
appender W "Database already exists" "%TEMP%\~tmp.txt"
if %ERRORLEVEL% == 1 goto suredrop
if %ERRORLEVEL% == 2 goto changename

:suredrop
if exist %temp%\~tmp.txt del %TEMP%\~tmp.txt
echo "Are you sure that you want to recreate the %DB_NAME% database?" > %TEMP%\~tmp.txt
appender W "Are you sure?" "%TEMP%\~tmp.txt"
if %ERRORLEVEL% == 1 goto dropdb
if %ERRORLEVEL% == 2 goto questiondrop

:dropdb
if exist %temp%\~tmp.txt del %TEMP%\~tmp.txt
call :print **** Dropping database %DB_NAME%
echo ATTACH TO %DB_INSTANCE% USER %DB_USERNAME% USING %DB_PASSWORD%; > %TEMP%\~tmp.sql
echo drop database %DB_NAME%; >> %TEMP%\~tmp.sql
db2cmd -c -w -i db2  -vf %TEMP%\~tmp.sql -t
del %TEMP%\~tmp.sql
goto callnewdb


:changename
if exist %temp%\~tmp.txt del %TEMP%\~tmp.txt
call :print **** Database "%DB_NAME%" already exists. Please choose another name.
:getname
appender t "Database name required" %temp%\~tmp.bat "Name"
call %temp%\~tmp.bat
del %temp%\~tmp.bat
set DB_NAME=%BIZ_PATH%
goto checkname

:callnewdb
call :print **** Running newdb.bat
pushd %BIZ_CONFIG_DIR%\pam_schema
CALL newdb %DB_NAME% %DB_USERNAME% %DB_PASSWORD% %BIZ_DB2DIR% %DB_SERVER_DIR% %DB_INSTANCE%

popd

goto end

rem *******************************************************************************
rem * print - echo line to screen and log file
rem *******************************************************************************
:print
set output=%1
if "%1" == "" goto printblankline
:print_nextparm
shift
if "%1" == "" goto endprint
set output=%output% %1
goto print_nextparm
:endprint
echo %output%
appender l "%output%" %BIZ_LOG%
goto :EOF
:printblankline
echo.
appender l "%output%" %BIZ_LOG%
goto :EOF

:nodbdir
call :print **** Cannot find DB2 Server directory - prompting user
appender t "Input location of DB2 Installation on DB2 Server machine" %temp%\~tmp.bat
call %temp%\~tmp.bat
IF "%BIZ_PATH%"=="" goto usernodb
SET DB_SERVER_DIR=%BIZ_PATH%
del %temp%\~tmp.bat
set BIZ_PATH=
goto dbdir

:remoteproblem
call :print **** Cannot connect to DB2 Server
SET BIZ_ERROR=1
goto end

:noname
call :print **** No Database name entered. Please try again.
goto getname

:usernodb
SET BIZ_ERROR=1
call :print **** Still cannot find DB2 Server directory
goto end

rem *******************************************************************************
rem *  Exit config                                                                *
rem *******************************************************************************

:end

call :Print --- Exiting PAM.bat
